package cn.com.tenlion.systembase.service.school;

import cn.com.tenlion.systembase.pojo.bos.school.SchoolBO;
import cn.com.tenlion.systembase.pojo.dtos.school.SchoolDTO;
import cn.com.tenlion.systembase.pojo.pos.school.SchoolPO;
import cn.com.tenlion.systembase.pojo.vos.school.SchoolVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: ISchoolService
 * @Description: 学校
 * @Author: CodeFactory
 * @Date: 2021-10-12 17:11:37
 * @Version: 3.0
 **/
public interface ISchoolService {

    /**
     * 新增学校
     *
     * @param schoolVO
     * @return
     */
    void save(SchoolVO schoolVO);

    /**
     * 新增学校
     *
     * @param token
     * @param schoolVO
     * @return
     */
    void save(String token, SchoolVO schoolVO);

    /**
     * 新增学校
     *
     * @param schoolVO
     * @return schoolId
     */
    String saveReturnId(SchoolVO schoolVO);

    /**
     * 新增学校
     *
     * @param token
     * @param schoolVO
     * @return schoolId
     */
    String saveReturnId(String token, SchoolVO schoolVO);

    /**
     * 删除学校
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids, String idsStr);


    /**
     * 删除学校
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids, String idsStr);

    /**
     * 删除学校（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改学校
     *
     * @param schoolId
     * @param schoolVO
     * @return
     */
    void update(String schoolId, SchoolVO schoolVO);

    /**
     * 修改学校
     *
     * @param token
     * @param schoolId
     * @param schoolVO
     * @return
     */
    void update(String token, String schoolId, SchoolVO schoolVO);

    /**
     * 学校详情
     *
     * @param params 参数Map
     * @return
     */
    SchoolDTO get(Map<String, Object> params);

    /**
     * 学校详情
     *
     * @param schoolId
     * @return
     */
    SchoolDTO get(String schoolId);

    /**
     * 学校详情
     *
     * @param params 参数Map
     * @return
     */
    SchoolBO getBO(Map<String, Object> params);

    /**
     * 学校详情
     *
     * @param schoolId
     * @return
     */
    SchoolBO getBO(String schoolId);

    /**
     * 学校详情
     *
     * @param params 参数Map
     * @return
     */
    SchoolPO getPO(Map<String, Object> params);

    /**
     * 学校详情
     *
     * @param schoolId
     * @return
     */
    SchoolPO getPO(String schoolId);

    /**
     * 学校列表
     *
     * @param params
     * @return
     */
    List<SchoolDTO> list(Map<String, Object> params);

    /**
     * 学校列表
     *
     * @param params
     * @return
     */
    List<SchoolBO> listBO(Map<String, Object> params);

    /**
     * 学校列表
     *
     * @param params
     * @return
     */
    List<SchoolPO> listPO(Map<String, Object> params);

    /**
     * 学校分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<SchoolDTO>> listPage(ListPage page);

    /**
     * 学校统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

    void saveKafka(String uid, SchoolVO schoolVO);

    void updateKafka(String uid, SchoolVO schoolVO);

    void deleteKafka(String uid);

}